unit HintBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Registry;

type
  TFormHintBox = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Memo1: TMemo;
    btnOk: TBitBtn;
    CheckBox1: TCheckBox;
    procedure btnOkClick(Sender: TObject);
  private
    { Private-Deklarationen }

  public
    hint, regkey:String;
    { Public-Deklarationen }
  end;

var
  FormHintBox: TFormHintBox;


procedure ShowHintW(key, header, text, checktext,  title:String; ico:TIcon);

implementation

{$R *.DFM}

function GetToken(aString, SepChar: String; TokenNum: Integer):String;
var
   Token     : String;
   StrLen    : Integer;
   TNum      : Integer;
   TEnd      : Integer;

begin
     StrLen := Length(aString);
     TNum   := 1;
     TEnd   := StrLen;
     while ((TNum <= TokenNum) and (TEnd <> 0)) do
     begin
          TEnd := Pos(SepChar,aString);
          if TEnd <> 0 then
          begin
               Token := Copy(aString,1,TEnd-1);
               Delete(aString,1,TEnd);
               Inc(TNum);
          end
          else
          begin
               Token := aString;
          end;
     end;
     if TNum >= TokenNum then
     begin
          GetToken := Token;
     end
     else
     begin
          GetToken := '';
     end;
end;

function NumToken(aString, SepChar: String):integer;
var
   RChar     : Char;
   StrLen    : integer;
   TNum      : integer;
   TEnd      : integer;

begin
     if SepChar = '#' then
     begin
          RChar := '*'
     end
     else
     begin
         RChar := '#'
     end;
     StrLen := Length(aString);
     TNum   := 0;
     TEnd   := StrLen;
     while TEnd <> 0 do
     begin
          Inc(TNum);
          TEnd := Pos(SepChar,aString);
          if TEnd <> 0 then
          begin
               aString[TEnd] := RChar;
          end;
     end;
     NumToken := TNum;
end;


function GetResString(nr: Integer): String;
var p: PChar;
begin
     p := StrAlloc(256);
     LoadString(Hinstance,nr,p,255);
     result := p;
     StrDispose(p);
end;

function getFromRes(nrString:String):String;
var nr:Integer;
begin
 try
  nr:=StrToInt(nrString); //If the text is a number in a string...
  Result:=GetResString(nr); //...get the real string from the resources
 except
  Result:=nrString;
  //Do nothing            //if not... ..see the comment
 end;
end;


procedure ShowHintW(key, header, text, checktext,  title:String; ico:TIcon);
var Reg  :TRegistry;
    keys :TStringList;
    x, nr:Integer;
    show :Boolean;
    hintf:TFormHintBox;
begin
hintf:=TFormHintBox.Create(Application); //Create the Form
hintf.regkey:=key; //Read into Form-members. We need this values in the btnOkClick-Procedure
hintf.hint:=text;  //dito
show:=True;        //show the window as standart
keys:=TStringList.Create;  //Initialize the StringList for all the Reg-Keys
Reg:=TRegistry.Create;     //Initialize the Reg-object
Reg.RootKey:=HKEY_CURRENT_USER; //Set the RootKey (You can Change it, if you would like to
Reg.OpenKey(key, true);         //Open the key. If it does not exist, create it
Reg.GetValueNames(keys);  //Read all values into ^the StringList
if keys.Count > 0 then    //We have an exception if we count to a list which does not exist...
begin
for x:=0 to (keys.Count-1) do
 begin
 if text = keys[x] then      //Compare the Text with an entry of the registry
   show:=Reg.ReadBool(text); //Show or not?
 end;
end
else
 show:=True;  //If the list does not exist, we have to show the window

If show then  //This is the sequence to initialize the form
 begin
 hintf.Caption:=title; //the caption

 header   :=GetFromRes(header);
 text     :=GetFromRes(text);
 checktext:=GetFromRes(checktext);
 title    :=GetFromRes(title);

 nr:=NumToken(text, #10);           //See readme.txt
 hintf.Memo1.Lines.Clear;           //Clear the Memo
 for x:=1 to nr do
  hintf.Memo1.Lines.Add(GetToken(text, #10, x));

 hintf.Checkbox1.Caption:=checktext; //The Caption of the Checkbox
 hintf.Label1.Caption:=Header;       //The cool Label at the top
 hintf.CheckBox1.Checked:=not show;  //The Checkbox...
 if ico=nil then    //If no icon is given...
  hintf.Image1.Picture.Icon:=Application.Icon //...display the application's icon...
 else                                         //...else...
  hintf.Image1.Picture.Icon:=ico;             //...display the given Icon.

 hintf.ShowModal; //Display the Form.
 end;
Reg.CloseKey;
Reg.Free;
keys.Free;
hintf.Free;
end;

procedure TFormHintBox.btnOkClick(Sender: TObject);
var Reg:TRegistry;
begin
Reg:=TRegistry.Create;
Reg.RootKey:=HKEY_CURRENT_USER;
Reg.OpenKey(regkey, true);
Reg.WriteBool(hint, not CheckBox1.Checked);
Reg.CloseKey;
Reg.Free;
end;

end.
